#!/usr/bin/perl

######################################################################
#                                                                    #
#  Dogsbody's Majordomo lists Script                                 #
#  Version 1.04                                                      #
#  Lasted Edited on 27 May 2007                                      #
#  Contact Dogsbody at dan@dogsbody.org                              #
#                                                                    #
#  Modifies the default majordomo config files as follows...         #
#  - Only shows lists you are subscribed to with the 'lists' command #
#  - Does not allow anyone to use the 'who' command to get addresses #
#  - Doesn't allow anyone to use the 'which' command to get addresses#
#                                                                    #
######################################################################
#                         EDIT BETWEEN HERE                          #
######################################################################

$mdlistdir = "/usr/local/majordomo/sites";

######################################################################
#                              AND HERE                              #
######################################################################

use File::Find;
find(\&found, $mdlistdir);
exit;

sub found
{
$file = $_;
if ($file =~ /.config$/)
 {
 @configfile = ();
 $change = 0;
 open(READCONFIG,"$file") || print "Cant open $file\n";
 while (<READCONFIG>)
  {
  if (/^who_access/)
   {
   if (/list$/)
    {$line = "who_access = closed\n";$change = 1;}
   else
    {$line = $_;}
   }
  elsif (/^which_access/)
   {$whichaccessfound = 1;}
  elsif (/^#AUTOSTOP/)
   {
   if ($whichaccessfound)
    {$line = $_;}
   else
    {$line = "which_access = closed\n" . $_;$change = 1}
   }
  elsif (/^END/)
   {
   if ($noadvertise)
    {
    if ($adsetall)
     {
     $line = $_;
     $adsetall = 0;
     }
    else
     {
     $line = "\/\.\*\/\n" . $_;
     $change = 1;
     }
    }
   else
    {
    $line = $_;
    }
   $advertise = 0;
   $noadvertise = 0;
   }
  elsif ($advertise)
   {
   if ($_ !~ /\/\.\*\//)
    {
    $line = $_;
    }
   else
    {
    $line = "";
    $change = 1;
    }
   }
  elsif ($noadvertise)
   {
   if (/\/\.\*\//)
    {
    $adsetall = 1;
    }
   $line = $_;
   }
  elsif (/^advertise /)
   {
   $line = $_;
   $advertise = 1;
   }
  elsif (/^noadvertise /)
   {
   $line = $_;
   $noadvertise = 1;
   }
  else
   {
   $line = $_;
   }
  push(@configfile,$line);
  }
 close (READCONFIG);
 if ($change)
  {
  print "File $File::Find::name has been changed\n";
  open(WRITECONFIG,">$file") || print "Cant open $file\n";
  foreach $line (@configfile)
   {
   print WRITECONFIG "$line";
   }
  close(WRITECONFIG);
  }
 }
}
